<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.4.549">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>r5</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
</style>


<script src="r5_files/libs/clipboard/clipboard.min.js"></script>
<script src="r5_files/libs/quarto-html/quarto.js"></script>
<script src="r5_files/libs/quarto-html/popper.min.js"></script>
<script src="r5_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="r5_files/libs/quarto-html/anchor.min.js"></script>
<link href="r5_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="r5_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="r5_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="r5_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="r5_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

<script type="text/javascript">
const typesetMath = (el) => {
  if (window.MathJax) {
    // MathJax Typeset
    window.MathJax.typeset([el]);
  } else if (window.katex) {
    // KaTeX Render
    var mathElements = el.getElementsByClassName("math");
    var macros = [];
    for (var i = 0; i < mathElements.length; i++) {
      var texText = mathElements[i].firstChild;
      if (mathElements[i].tagName == "SPAN") {
        window.katex.render(texText.data, mathElements[i], {
          displayMode: mathElements[i].classList.contains('display'),
          throwOnError: false,
          macros: macros,
          fleqn: false
        });
      }
    }
  }
}
window.Quarto = {
  typesetMath
};
</script>

</head>

<body class="fullcontent">

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">

<main class="content" id="quarto-document-content">




<div class="cell">
<style type="text/css">
.justify {
  text-align: justify !important
}
</style>
</div>
<section id="wytyczne-w-zakresie-ukrywania-przekrojów-objętych-tajemnicą-statystyczną-w-systemie-informatycznym-badania-sib" class="level1">
<h1>Wytyczne w zakresie ukrywania przekrojów objętych tajemnicą statystyczną w Systemie Informatycznym Badania (SIB)</h1>
<div class="justify">
<p>Systemy Informatyczne Badań (SIB), które stanowią rozwiązania w zakresie przetwarzania i opracowania danych statystycznych, są dobrym miejscem do implementacji procesów ukrywania przekrojów objętych tajemnicą statystyczną, gdyż, zazwyczaj, są pierwszym źródłem agregatów dla danej edycji badania. Naliczanie tablic agregatów w SIB może być połączone z oznaczaniem rekordów podlegających ochronie ze względu na tajemnicę statystyczną. Najpopularniejsza platforma SIB – SPDS, opracowana przez Urząd Statystyczny w Olsztynie, nie zawiera uniwersalnego rozwiązania w zakresie ukrywania przekrojów objętych tajemnicą statystyczną, ale umożliwia wdrożenie własnego rozwiązania uwzględniającego specyfikę dziedzinową każdego z badań. Procesy ukrywania przekrojów objętych tajemnicą statystyczną mogą być umieszczone w ramach procedur naliczających tablice agregatów lub być częścią bardziej rozbudowanego modułu sterowania przebiegiem procesów w ramach badania. Brak uniwersalnego rozwiązania w ramach platformy powoduje, że to na projektancie/programiście SIB będzie spoczywał obowiązek implementacji procesów ukrywania przekrojów objętych tajemnicą statystyczną, które powinny obejmować co najmniej ukrycie pierwotne, choć w ramach rekomendacji wskazane jest podjęcie prac wspólnie z jednostką autorską, aby zalgorytmizować i wdrożyć również proces ukrywania wtórnego. Poniższe wytyczne mają na celu wskazanie kierunku prac – nakierowanie projektantów i programistów SIB w zakresie opracowania algorytmu technicznego i implementacji rozwiązania oraz odesłanie do właściwych dokumentów, które pomogą stworzyć dziedzinowe algorytmy, a więc dostosowane do specyfiki badań.</p>
<ol type="1">
<li>Ukrywanie agregatów objętych tajemnicą statystyczną w SIB powinno obejmować co najmniej ukrycie pierwotne w oparciu o metodę deterministyczną (rozdział 5.1).</li>
<li>Rozwiązanie w zakresie ukrycia pierwotnego powinno zostać zintegrowane z procesem naliczania tablic – każda tablica powinna mieć oznaczone agregaty (rozdział 4.2.2) wymagające ukrycia, a w przypadku tablic publikacyjnych wskazany agregat powinien zostać zastąpiony odpowiednim symbolem tajemnicy, który jest stosowany w publikacjach, tj. kropką<a href="#fn1" class="footnote-ref" id="fnref1" role="doc-noteref"><sup>1</sup></a>.</li>
<li>Rozwiązanie wdrożone w zakresie ukrywania przekrojów objętych tajemnicą statystyczną powinno opierać się na zaleceniach zawartych w Przewodniku oraz założeniach opracowanych przez jednostkę autorską badania.</li>
<li>Lista kodów – propozycja oznaczeń wystąpienia tajemnicy statystycznej została opracowana i zamieszczona w Przewodniku (rozdział 4.2.2). Wskazane jest rozróżnienie i oznaczenie agregatów wymagających ukrycia ze względu na weryfikowane kryteria (kryterium liczebności lub/i kryterium dominacji), które były podstawą do ukrycia agregatów objętych tajemnicą statystyczną.</li>
<li>Kolumna z wyróżnikiem tajności dla występujących w tablicy agregatów powinna być integralną częścią tablicy naliczanej w SIB.</li>
<li>Na etapie przetwarzania i naliczania agregatów konieczne będzie utworzenie dodatkowych zmiennych zawierających informacje o liczebności jednostek oraz udziałów jednostek dominujących w wartości agregatu dla poszczególnych zmiennych stanowiących dominanty w badaniu (opisane w rozdziale 4.3), które posłużą do weryfikacji kryteriów ukrywania przekrojów objętych tajemnicą statystyczną. Powyższe zmienne operacyjne nie są wymagane do umieszczenia w wyjściowej tablicy agregatów.</li>
<li>Wskazana forma implementacji rozwiązania w zakresie ukrywania przekrojów objętych tajemnicą statystyczną to obiekt bazodanowy typu widok, funkcja lub procedura składowana.</li>
<li>W przypadku implementacji rozwiązania również w zakresie ukrycia wtórnego pomocne mogą się okazać opisane poniżej w rozdziale <a href="#sec-part5_1" class="quarto-xref">Section&nbsp;1.1</a> Wytyczne odnośnie pierwotnego i wtórnego ukrycia w oparciu o metodę deterministyczną ukrywania komórek, zawierające szczegółowe zagadnienia, które zaleca się uwzględnić w projekcie technicznym rozwiązania informatycznego przygotowywanego przez projektanta/programistę.</li>
</ol>
<section id="sec-part5_1" class="level2">
<h2 class="anchored" data-anchor-id="sec-part5_1">Wytyczne odnośnie pierwotnego i wtórnego ukrycia w oparciu o metodę deterministyczną ukrywania komórek</h2>
<p>Metoda deterministyczna (oparta na ściśle zaprogramowanych regułach) ukrywania komórek w zakresie ukrycia pierwotnego i wtórnego opiera się na identyfikacji, opisie biznesowym oraz zalgorytmizowaniu przypadków stosowania ochrony przekrojów poprzez ich ukrycie. W przypadku ukrycia pierwotnego powyższe zadanie nie jest zbyt skomplikowane, ale jeśli rozwiązanie ma obejmować również ukrycie wtórne, stopień skomplikowania wzrasta gwałtownie. Całościowe i preferowane podejście do procesu ukrywania przekrojów objętych tajemnicą statystyczną powinno obejmować zestawy tablic publikacyjnych i wynikowych z poszczególnych populacji/zbiorowości wyodrębnionych w ramach pełnej zbiorowości badania, które mogą obejmować również przekroje zawierające krzyżujące się wielopoziomowe wymiary o strukturze hierarchicznej. Ze względu na specyfikę badań i występujących w tablicach przekrojów, które mają wpływ na liczbę przypadków wtórnego ukrycia agregatów, wskazane jest indywidualne podejście do tego zagadnienia w ramach badania/zestawu tablic z danej populacji. Poniższe wytyczne mają na celu wskazać drogę projektantowi/programiście SIB w zakresie tworzenia projektu technicznego rozwiązania uwzględniającego specyfikę danego badania. Już na początku tego procesu, należy przyjąć założenie, że automatyzacja w zakresie ukrycia pierwotnego i wtórnego może nie być w pełni możliwa do realizacji. Jako ostatni element procesu należy uwzględnić weryfikację propozycji ukrycia wtórnego przez jednostkę autorską badania, zmierzającą do minimalizacji poziomu utraty informacji. Optymalizacja w tym zakresie może być bardzo wymagająca, a w niektórych przypadkach niemożliwa do wdrożenia w formie zautomatyzowanej ze względu na występowanie nieopisanej i niemożliwej do ustalenia na etapie projektowania liczby przypadków oraz pojawianie się bezprecedensowych zależności. Poniżej przedstawiono listę czynności i zagadnień, do uwzględnienia przez projektanta/programistę SIB przy opracowywaniu projektu technicznego rozwiązania informatycznego w zakresie pierwotnego i wtórnego ukrycia w oparciu o metodę deterministyczną ukrywania komórek.</p>
<ol type="1">
<li><p>Utworzenie algorytmów wyodrębniających populacje/zbiorowości, na których będą naliczane poszczególne agregaty i będą ukrywane (oznaczane do ukrycia) przekroje wymagające ochrony ze względu na tajemnicę statystyczną. Zaleca się zebranie, w miarę możliwości, wszystkich tablic wynikowych i publikacyjnych dla poszczególnych zbiorowości, wyodrębnienie przekrojów, czyli kombinacji wszystkich wymiarów – ich wzajemnych skrzyżowań oraz zmiennych, dla których naliczone zostaną agregaty (zmienne zostaną wykorzystane dopiero w końcowej fazie przetwarzania zbioru). Należy zwrócić szczególną uwagę na wymiary hierarchiczne i liczbę poziomów, które będą wykorzystywane w tablicach (każdy poziom należy traktować jako oddzielny wymiar). Każdy wymiar to dedykowana kolumna w zbiorze.</p></li>
<li><p>Określenie sposobu wyodrębnienia i oznaczenia (ponumerowania) zestawów wymiarów wygenerowanych w ramach zbioru z danego badania wraz z określeniem ich hierarchii – podstawą wyodrębnienia zestawów wymiarów powinno być określenie skrzyżowań wymiarów. Najwyższy poziom określają wartości ogółem dla wszystkich wymiarów (zestaw wymiarów najwyższego poziomu) w zbiorze aż do najniższego poziomu, czyli skrzyżowania wszystkich wymiarów bez żadnej wartości ogółem. Oznaczenie powinno umożliwiać wyszukiwanie odrębnych zestawów wymiarów na poszczególnych poziomach.</p></li>
<li><p>Opracowanie algorytmu technicznego dla modułu ogólnego ukrywania przekrojów objętych tajemnicą statystyczną ze szczególnym uwzględnieniem poniższych kwestii (wytyczne metodologiczne zostały szczegółowo wyjaśnione w rozdziale nr 4):</p>
<ol type="a">
<li>Jakie są zasady ukrywania pierwotnego?</li>
<li>Czy jest weryfikowana liczebność i sprawdzana zasada dominacji dla każdej zmiennej, czy też jest określona jedna lub więcej zmiennych tzw. dominant, dla których następuje weryfikacja kryterium dominacji? W przypadku weryfikacji kryterium dominacji, dla każdej zmiennej należy określić zasady weryfikacji dla zmiennych przyjmujących wartości dodatnie i ujemne. Należy zwrócić szczególną uwagę na zbiorowości zawierające dane reprezentacyjne z wagami, dla których mogą występować uproszczone zasady ukrycia pierwotnego.</li>
<li>Czy wartość <span class="math inline">\(0\)</span> w zbiorze jest znacząca, czy też oznacza brak występowania zjawiska? Jak traktowane są wartości zerowe w procesie ukrywania przekrojów objętych tajemnicą statystyczną?</li>
<li>Czy wszystkie zmienne podlegają ochronie w przypadku spełnienia warunków ukrycia przekrojów objętych tajemnicą statystyczną? Zazwyczaj liczebność nie podlega ochronie. Wyjątki mogą również dotyczyć wskaźników ilorazowych.</li>
<li>W przypadku konieczności stosowania zasad tajemnicy statystycznej do wskaźników ilorazowych należy ustalić, czy następuje weryfikacja zarówno licznika, jak i mianownika oraz czy spełnienie kryteriów objęcia tajemnicą miar składowych wskaźnika (jednej – licznika lub mianownika bądź obu) powoduje konieczność objęcia ochroną wskaźnika wyliczanego w oparciu o powyższe miary.</li>
<li>Jakie są szczegółowe zasady ukrywania wtórnego? Jaki jest sposób doboru agregatów do ukrycia wtórnego? W tym przypadku może decydować np. zasada minimalizacji zbiorowości lub minimalizacja wartości dominanty dla przekrojów kandydujących do ukrycia, ewentualnie wskazanie może być dokonywane w oparciu o bardziej skomplikowany model decyzyjny oparty np. na wagach.</li>
<li>Czy w przypadku ukrywania wtórnego ze względu na kryterium dominacji konieczna jest weryfikacja, czy maksimum jednostkowe w stosunku do sumy agregatów (objętych ukryciem pierwotnym i wtórnym) jest mniejsze niż 75% wartości agregatu (tzw. zasada pokrycia)? W hipotetycznym przykładzie występowania dwóch rekordów podlegających ukryciu pierwotnemu ze względu na liczebność (w obu agregatach po 1 jednostce) przyjmuje się jako oczywistość konieczność objęcia kolejnego agregatu ukryciem wtórnym, ale w przypadku kryterium dominacji nie jest to już tak oczywiste.</li>
</ol></li>
<li><p>Wyodrębnienie i opracowanie dodatkowych specyficznych modułów nakładania tajemnicy statystycznej, w przypadku występowania skomplikowanych zależności pomiędzy wymiarami w ramach danej zbiorowości, które nie mogą być obsłużone przez moduł ogólny. Zaleca się wdrożenie modułów ukrywania wtórnego według podejścia top-down i od ogółu do szczegółu, zaczynając od głównych wymiarów niehierarchicznych, a w przypadku wymiarów hierarchicznych – od najwyższych poziomów. Moduły powinny być wykorzystywane iteracyjnie – należy zaplanować kolejność ich uruchamiania, mając na uwadze, że w przypadku rozbudowanych zbiorów danych lub zestawów tablic efekty działania poszczególnych modułów będą miały wpływ na pozostałe moduły, stąd wskazane jest wielokrotne uruchamianie sekwencji modułów (wskazane jest przetestowanie różnych sekwencji modułów w celu wybrania rozwiązania optymalnego). Działanie najbardziej ogólnego modułu powinno polegać na sprawdzeniu liczby wystąpień ukryć pierwotnych na poziomie zestawu wymiarów, a w przypadku niedostatecznej liczby tych utajnień, na wskazaniu agregatu bądź agregatów (na poziomie danego zestawu wymiarów) do ukrycia wtórnego.</p></li>
<li><p>Opracowanie modułów weryfikujących specyficzne rodzaje ukrycia wtórnego w zakresie wymiarów hierarchicznych (uruchamiane po module ogólnym), aby nie było możliwe odkrycie agregatu podlegającego ukryciu wtórnemu na wyższym poziomie poprzez agregację wartości na niższych poziomach. Im więcej poziomów hierarchicznych, tym więcej modułów weryfikacyjnych należy opracować i ustawić w sekwencji uruchamiania. Wskazane jest utworzenie modułów sprawdzających, wyszukujących specyficzne rodzaje ukrycia wtórnego, które nie mogą być obsłużone przez moduł ogólny.</p></li>
<li><p>Agregacja miar (liczby jednostek oraz zmiennych wykorzystywanych do sprawdzenia kryterium dominacji) według przekrojów publikacyjnych wraz z oznaczeniem ukrycia pierwotnego (z rozróżnieniem na kryterium liczebności i dominacji) oraz oznaczenie zestawów wymiarów. Zaleca się wykorzystanie klauzul grouping sets, funkcji grouping(), funkcji sumowania dla liczby jednostek i dominanty oraz funkcji maksimum dla wyliczenia maksymalnego udziału jednostkowego w kryterium dominacji, a także funkcji rankingowych języka T-SQL do numerowania zestawów wymiarów.</p></li>
<li><p>Agregacja liczby wystąpień ukrycia pierwotnego na poziomie każdego z wyróżnionych zestawów wymiarów.<br>
</p></li>
<li><p>Ułożenie kolejności i ustawienie sekwencji uruchamiania modułów nakładania i weryfikacji nałożenia tajemnicy statystycznej w oparciu o podejście top-down i od ogółu do szczegółu. Kilkukrotne uruchomienie sekwencji modułów, aż do momentu gdy żaden z modułów nie będzie zwracał rekordów do oznaczenia ukrycia wtórnego, będzie wskazaniem do zakończenia procesu kontroli ujawniania danych statystycznych w oparciu o opracowany algorytm.</p></li>
<li><p>Przełożenie wskazań przekrojów do ukrycia z zestawów wymiarów na zagregowane wartości zmiennych według przekrojów publikacyjnych. Należy pamiętać, że nie wszystkie zmienne muszą podlegać ochronie. Końcowym elementem procesu ukrywania przekrojów objętych tajemnicą statystyczną w oparciu o metodę deterministyczną ukrywania komórek powinna być weryfikacja dokonana przez eksperta (autora opracowania) i ewaluacja ze wskazaniem przekrojów do zdjęcia i/lub nałożenia ochrony ze względu na możliwość zastosowania bardziej optymalnego rozwiązania i minimalizację poziomu utraty informacji. Każda tego typu informacja zwrotna od eksperta może być wykorzystana przez projektanta/programistę SIB do modyfikacji i udoskonalania algorytmu poprzez dodanie obsługi nowych bądź optymalizację już obsługiwanych przypadków (dodanie/modyfikację modułów obsługujących określone przypadki ukrywania rekordów dla danego zestawu agregatów).</p></li>
</ol>
</section>
</div>
</section>


<div id="quarto-appendix" class="default"><section id="footnotes" class="footnotes footnotes-end-of-document" role="doc-endnotes"><h2 class="anchored quarto-appendix-heading">Footnotes</h2>

<ol>
<li id="fn1"><p>Objaśnienia znaków umownych stosowanych w statystyce (załącznik nr 2 do protokołu KR_1/2020), <a href="http://intranet/GUS/os/kr/Protokoy%20z%20posiedze/Forms/AllItems.aspx?RootFolder=%2FGUS%2Fos%2Fkr%2FProtokoy%20z%20posiedze%2FProtoko%C5%82y%5F2020%2FProtok%C3%B3%C5%82%201%5F2020%20%2B%20za%C5%82%C4%85czniki&amp;FolderCTID=0x012000E10BF0432A82F7489EC37EE041DC46A3&amp;View=%7B68E12AB5%2DBE1C%2D483A%2D9D2E%2DB975C5B173A5%7D#InplviewHash68e12ab5-be1c-483a-9d2e-b975c5b173a5=FolderCTID%3D0x012000E10BF0432A82F7489EC37EE041DC46A3-RootFolder%3D%252FGUS%252Fos%252Fkr%252FProtokoy%2520z%2520posiedze%252FProtoko%25C5%2582y%255F2020%252FProtok%25C3%25B3%25C5%2582%25201%255F2020%2520%252B%2520za%25C5%2582%25C4%2585czniki">Protokół 1_2020 załączniki - Wszystkie dokumenty</a> (dostęp 29.11.2022).<a href="#fnref1" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
</ol>
</section></div></main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->




</body></html>